package com.cool.hot100.multi_dp;

import org.junit.Test;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/28/11:48
 * @Description: 5. 最长回文子串
 * Hard 2
 * Level 5
 * @Link https://leetcode.cn/problems/longest-palindromic-substring/description/?envType=study-plan-v2&envId=top-100-liked
 */
public class Num5 {

    /**
     * 中心扩散
     *
     * @param s
     * @return
     */
    public String longestPalindrome(String s) {
        int res = 0;
        int left = 0, right = 0;
        char[] chars = s.toCharArray();
        int maxLeft = 0, maxRight = 0;
        for (int i = 0; i < chars.length; i++) {
            left = i - 1;
            right = i + 1;
            int tempLen = 1;
            //向左延伸，寻找相等字符
            while (left >= 0 && chars[left] == chars[i]) {
                left--;
                tempLen++;
            }
            //向右延伸，寻找相等字符
            while (right < chars.length && chars[right] == chars[i]) {
                right++;
                tempLen++;
            }
            //向两边扩散，此前的字符已为回文子串，因此向左右扩散的字符相等，则新的子串也为回文子串
            while (left >= 0 && right < chars.length) {
                if (chars[left] != chars[right]) {
                    break;
                }
                tempLen += 2;
                left--;
                right++;
            }
            if (res < tempLen) {
                maxLeft = left;
                maxRight = right;
                res = tempLen;
            }

        }
        return s.substring(maxLeft + 1, maxRight);
    }

    public String longestPalindrome1(String s) {

        if (s == null || s.length() == 0) {
            return "";
        }
        int strLen = s.length();
        int left = 0;
        int right = 0;
        int len = 1;
        int maxStart = 0;
        int maxLen = 0;

        for (int i = 0; i < strLen; i++) {
            left = i - 1;
            right = i + 1;
            while (left >= 0 && s.charAt(left) == s.charAt(i)) {
                len++;
                left--;
            }
            while (right < strLen && s.charAt(right) == s.charAt(i)) {
                len++;
                right++;
            }
            while (left >= 0 && right < strLen && s.charAt(right) == s.charAt(left)) {
                len = len + 2;
                left--;
                right++;
            }
            if (len > maxLen) {
                maxLen = len;
                maxStart = left;
            }
            len = 1;
        }
        return s.substring(maxStart + 1, maxStart + maxLen + 1);

    }

    /**
     * 动态规划
     *
     * @Author Cool
     * @Date 14:11 2024/9/28
     **/
    public String longestPalindrome3(String s) {
        int res = 0;
        char[] chars = s.toCharArray();
        int maxLeft = 0, maxRight = 0;
        boolean[][] dp = new boolean[chars.length][chars.length];
        for (int right = 1; right < chars.length; right++) {
            for (int left = 0; left < right; left++) {
                if (chars[left] == chars[right] && (right - left <= 2 || dp[left + 1][right - 1])) {
                    dp[left][right] = true;
                    if (right - left > maxRight - maxLeft) {
                        maxLeft = left;
                        maxRight = right;
                    }
                }
            }
        }
        return s.substring(maxLeft, maxRight + 1);
    }

    @Test
    public void test() {
        longestPalindrome1("a");
    }
}
